<?php

include_once "inc/config.php";

if (!file_exists(data_DB) || !file_exists(data_CONFIG))
{
    header("Location: setup.php");
    exit(0);
}

include_once data_CONFIG;

$title = "NMT CSI IPTV";
include "inc/top.php";

/*
 * Autorun
 */

include_once "inc/udpxy.php";
udpxy_check_start();

/*
 * DB
 */

$pdo = new PDO('sqlite:' . data_DB);
$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

/*
 * A200 seems has table row limit
 * 100 rows max
 * so making a workaround for this
 */

$linecnt = 0;

function start_table()
{
    global $linecnt;
    $linecnt = 0;
    echo "<table>";
}

function end_table()
{
    global $linecnt;
    echo "</table> <!-- linecnt = $linecnt -->";
}

function next_table()
{
    global $linecnt;
    if ($linecnt > 9)
    {
        end_table();
        start_table();
    }
}

function next_line()
{
    global $linecnt;
    ++$linecnt;
}

function start_table_row()
{
    global $linecnt;
    next_table();
    echo "<tr> <!-- linecnt = $linecnt -->";
}

function end_table_row()
{
    global $linecnt;
    echo "</tr> <!-- linecnt = $linecnt -->";
    next_line();
}

/*
 * View utils
 */

function echo_prev_next_day_tag()
{
    global $view, $offset;
?>
<?php start_table_row(); ?>
    <td colspan=2 align=left><a href="<?php echo "index.php?view=$view&offset=" . ($offset - 86400); ?>"><?php echo date('j F, l', time() + $offset - 86400); ?></a></td>
    <td colspan=2 align=right><a href="<?php echo "index.php?view=$view&offset=" . ($offset + 86400); ?>"><?php echo date('j F, l', time() + $offset + 86400); ?></a></td>
<?php end_table_row(); ?>
<?php
}

function channel_url($url)
{
    global $settings;

    if (isset($settings["fix_urls"]) && $settings["fix_urls"])
    {
        $url = str_replace("rtp://@", "udp://", $url);
        $url = str_replace("rtp://", "udp://", $url);
        $url = str_replace("udp://@", "udp://", $url);
    }

    if (isset($settings["udpxy"]) && $settings["udpxy"])
    {
        $url = str_replace("rtp://@", "http://". $settings["udpxy"] . "/udp/", $url);
        $url = str_replace("udp://@", "http://". $settings["udpxy"] . "/udp/", $url);
        $url = str_replace("rtp://", "http://". $settings["udpxy"] . "/udp/", $url);
        $url = str_replace("udp://", "http://". $settings["udpxy"] . "/udp/", $url);
    }

    if (isset($settings["proxy"]) && $settings["proxy"])
    {
        $url = "proxy.php?url=" . urlencode($url);
    }

    return $url;
}

function channel_url_tag($name, $url)
{
    global $offset, $settings;

    if ($offset)
        return htmlspecialchars($name);
    else
        return "<a href=\"" . channel_url($url) . "\" vod"
            . ($settings["prebuf"] ? " prebuf=" . $settings["prebuf"] : "")
            . ">" . htmlspecialchars($name) . "</a>";
}

function programme_url($channel_id)
{
    global $view;
    global $offset;

    return "programme.php?view=$view&channel=$channel_id&offset=$offset";
}

/*
 * Views
 */

function view_all()
{
    global $pdo, $offset;
?>
<?php start_table(); ?>
<?php start_table_row(); ?>
    <th colspan=2>All channels</th>
    <th colspan=2><?php echo date('H:i, j F, l', time() + $offset); ?></th>
<?php end_table_row(); ?>
<?php echo_prev_next_day_tag(); ?>
<?php
    $sql = "select channels.id as id, channels.name as name, channels.url as url, channels.icon as icon from channels";
    foreach ($pdo->query($sql) as $channel_row)
    {
?>
<?php start_table_row(); ?>
    <td>
        <img src="<?php echo $channel_row["icon"]; ?>">
    </td>
    <td>
        <?php echo channel_url_tag($channel_row["name"], $channel_row["url"]); ?>
    </td>
<?php
        $sql = "select programmes.name as name, timetable.time_start as start, timetable.time_stop as stop"
            . " from timetable, programmes"
            . " where timetable.channel_id = " . $channel_row["id"] . " and timetable.time_start <= " . (time() + $offset) . " and timetable.time_stop > " . (time() + $offset)
            . " and programmes.id = timetable.programme_id";
        #error_log("sql: $sql");
        foreach ($pdo->query($sql) as $programme_row)
        {
?>
    <td nowrap>
        <?php echo date('H:i', $programme_row["start"]), "-", date('H:i', $programme_row["stop"]); ?>
    </td>
    <td>
        <a href="<?php echo programme_url($channel_row["id"]); ?>"><?php echo htmlspecialchars($programme_row["name"]); ?></a>
    </td>
<?php
        }
?>
<?php end_table_row(); ?>
<?php
    }
?>
<?php end_table(); ?>
<?php
}

function view_channel_categories()
{
    global $pdo, $offset;
?>
<?php start_table(); ?>
<?php start_table_row(); ?>
    <th colspan=2>Channel categories</th>
    <th colspan=2><?php echo date('H:i, j F, l', time() + $offset); ?></th>
<?php end_table_row(); ?>
<?php echo_prev_next_day_tag(); ?>
<?php
    $sql = "select id, name from channel_categories";
    foreach ($pdo->query($sql) as $channel_category_row)
    {
        if (!$channel_category_row["name"])
            continue;
?>
<?php start_table_row(); ?>
    <th colspan=2><?php echo $channel_category_row["name"]; ?></th>
<?php end_table_row(); ?>
<?php
        $sql = "select url, name, id, icon"
            . " from channels"
            . " where channels.category_id = " . $channel_category_row["id"];
        foreach ($pdo->query($sql) as $channel_row)
        {
?>
<?php start_table_row(); ?>
    <td>
        <img src="<?php echo $channel_row["icon"]; ?>">
    </td>
    <td>
        <?php echo channel_url_tag($channel_row["name"], $channel_row["url"]); ?>
    </td>
<?php
            $sql = "select programmes.name as name, timetable.time_start as start, timetable.time_stop as stop"
                . " from timetable, programmes"
                . " where timetable.channel_id = " . $channel_row["id"]
                . " and timetable.time_start <= " . (time() + $offset) . " and timetable.time_stop > " . (time() + $offset)
                . " and programmes.id = timetable.programme_id";
            #error_log("sql: $sql");
            foreach ($pdo->query($sql) as $programme_row)
            {
?>
    <td nowrap>
        <?php echo date('H:i', $programme_row["start"]), "-", date('H:i', $programme_row["stop"]); ?>
    </td>
    <td>
        <a href="<?php echo programme_url($channel_row["id"]); ?>"><?php echo htmlspecialchars($programme_row["name"]); ?></a>
    </td>
<?php
            }
?>
<?php end_table_row(); ?>
<?php
        }
    }
?>
<?php end_table(); ?>
<?php
}

function view_programme_categories()
{
    global $pdo, $offset;
?>
<?php start_table(); ?>
<?php start_table_row(); ?>
    <th colspan=2>Programme categories</th>
    <th colspan=2><?php echo date('H:i, j F, l', time() + $offset); ?></th>
<?php end_table_row(); ?>
<?php echo_prev_next_day_tag(); ?>
<?php
    $sql = "select id, name from programme_categories";
    foreach ($pdo->query($sql) as $programme_category_row)
    {
        if (!$programme_category_row["name"])
            continue;
?>
<?php start_table_row(); ?>
<th colspan=2><?php echo $programme_category_row["name"]; ?></th>
<?php end_table_row(); ?>
<?php
        $sql = "select programmes.name as name, timetable.time_start as start, timetable.time_stop as stop, channels.url as chan_url, channels.name as chan_name, timetable.channel_id as chan_id, channels.icon as chan_icon"
            . " from timetable, programmes, channels"
            . " where programmes.category_id = " . $programme_category_row["id"] . " and timetable.programme_id = programmes.id"
            . " and timetable.time_start <= " . (time() + $offset) . " and timetable.time_stop > " . (time() + $offset)
            . " and channels.id = timetable.channel_id";
        #error_log("sql: $sql");
        foreach ($pdo->query($sql) as $programme_row)
        {
?>
<?php start_table_row(); ?>
<td>
    <img src="<?php echo $programme_row["chan_icon"]; ?>">
</td>
<td>
    <?php echo channel_url_tag($programme_row["chan_name"], $programme_row["chan_url"]); ?>
</td>
<td nowrap>
    <?php echo date('H:i', $programme_row["start"]), "-", date('H:i', $programme_row["stop"]); ?>
</td>
<td>
    <a href="<?php echo programme_url($programme_row["chan_id"]); ?>"><?php echo htmlspecialchars($programme_row["name"]); ?></a>
</td>
<?php
        }
?>
<?php end_table_row(); ?>
<?php
    }
?>
<?php end_table(); ?>
<?php
}

function view_playlists()
{
    global $pdo, $offset;
?>
<?php start_table(); ?>
<?php start_table_row(); ?>
    <th colspan=2>Playlists</th>
    <th colspan=2><?php echo date('H:i, j F, l', time() + $offset); ?></th>
<?php end_table_row(); ?>
<?php echo_prev_next_day_tag(); ?>
<?php
    $sql = "select id, name from playlists";
    foreach ($pdo->query($sql) as $playlist_row)
    {
        if (!$playlist_row["name"])
            continue;
?>
<?php start_table_row(); ?>
    <th colspan=2><?php echo $playlist_row["name"]; ?></th>
<?php end_table_row(); ?>
<?php
        $sql = "select channels.url as url, channels.name as name, playlist_channels.channel_id as id, channels.icon as icon"
            . " from playlist_channels, channels"
            . " where playlist_channels.playlist_id = " . $playlist_row["id"]
            . " and channels.id = playlist_channels.channel_id";
        foreach ($pdo->query($sql) as $channel_row)
        {
?>
<?php start_table_row(); ?>
    <td>
        <img src="<?php echo $channel_row["icon"]; ?>">
    </td>
    <td>
        <?php echo channel_url_tag($channel_row["name"], $channel_row["url"]); ?>
    </td>
<?php
            $sql = "select programmes.name as name, timetable.time_start as start, timetable.time_stop as stop"
                . " from timetable, programmes"
                . " where timetable.channel_id = " . $channel_row["id"]
                . " and timetable.time_start <= " . (time() + $offset) . " and timetable.time_stop > " . (time() + $offset)
                . " and programmes.id = timetable.programme_id";
            #error_log("sql: $sql");
            foreach ($pdo->query($sql) as $programme_row)
            {
?>
    <td nowrap>
        <?php echo date('H:i', $programme_row["start"]), "-", date('H:i', $programme_row["stop"]); ?>
    </td>
    <td>
        <a href="<?php echo programme_url($channel_row["id"]); ?>"><?php echo htmlspecialchars($programme_row["name"]); ?></a>
    </td>
<?php
            }
?>
<?php end_table_row(); ?>
<?php
        }
    }
?>
<?php end_table(); ?>
<?php
}

function view_xmltv_listings()
{
    global $pdo, $offset;
?>
<?php start_table(); ?>
<?php start_table_row(); ?>
    <th colspan=2>XMLTV listings</th>
    <th colspan=2><?php echo date('H:i, j F, l', time() + $offset); ?></th>
<?php end_table_row(); ?>
<?php echo_prev_next_day_tag(); ?>
<?php
    $sql = "select id, name from xmltvs";
    foreach ($pdo->query($sql) as $xmltv_row)
    {
        if (!$xmltv_row["name"])
            continue;
?>
<?php start_table_row(); ?>
<th colspan=2><?php echo $xmltv_row["name"]; ?></th>
<?php end_table_row(); ?>
<?php
        $sql = "select programmes.name as name, timetable.time_start as start, timetable.time_stop as stop, channels.url as chan_url, channels.name as chan_name, timetable.channel_id as chan_id, channels.icon as chan_icon"
            . " from xmltv_timetable, timetable, programmes, channels"
            . " where xmltv_timetable.xmltv_id = " . $xmltv_row["id"]
            . " and timetable.id = xmltv_timetable.timetable_id"
            . " and timetable.time_start <= " . (time() + $offset) . " and timetable.time_stop > " . (time() + $offset)
            . " and programmes.id = timetable.programme_id"
            . " and channels.id = timetable.channel_id";
        #error_log("sql: $sql");
        foreach ($pdo->query($sql) as $programme_row)
        {
?>
<?php start_table_row(); ?>
<td>
    <img src="<?php echo $programme_row["chan_icon"]; ?>">
</td>
<td>
    <?php echo channel_url_tag($programme_row["chan_name"], $programme_row["chan_url"]); ?>
</td>
<td nowrap>
    <?php echo date('H:i', $programme_row["start"]), "-", date('H:i', $programme_row["stop"]); ?>
</td>
<td>
    <a href="<?php echo programme_url($programme_row["chan_id"]); ?>"><?php echo htmlspecialchars($programme_row["name"]); ?></a>
</td>
<?php
        }
?>
<?php end_table_row(); ?>
<?php
    }
?>
<?php end_table(); ?>
<?php
}

$views = array(
                "All" => 'view_all',
                "Channel categories" => 'view_channel_categories',
                "Programme categories" => 'view_programme_categories',
                "Playlists" => 'view_playlists',
                "XMLTV listings" => 'view_xmltv_listings'
);

if (isset($_GET["view"]))
    $view = $_GET["view"];
else
    $view = "";

if (!isset($views[$view]))
{
    $view_options = array_keys($views);
    $view = $view_options[0];
}

$offset = 0;
if (isset($_GET["offset"]))
    $offset = $_GET["offset"];
?>

<hr>
<?php start_table(); ?>
<?php start_table_row(); ?>
<?php
if ($offset)
    echo "<td><a href=\"index.php?view=", urlencode($view), "&offset=0\">Today</a></td>";
foreach (array_keys($views) as $name)
{
    echo "<td>";
    if ($name != $view)
    {
        echo "<a href=\"index.php?view=", urlencode($name), "&offset=$offset\">$name</a>";
    }
    else
    {
        echo $name;
    }
    echo "</td>";
}
?>
<td><a href="setup.php">Setup</a></td>
<?php end_table_row(); ?>
<?php end_table(); ?>

<hr>
<?php call_user_func($views[$view]); ?>

<hr>

<?php
include "inc/bottom.php";
?>
